#include <cstdlib>

#include "rand.h"

#include "gamemanager.h"

int Rand::roll(int n, bool store)
{
  man->disableUndo();
  if (man->isInReplayMode()) {
    const char *val = man->getRecord().latin1();
    char tmp[100];
    int nb;
    sscanf(val,"%s %d",tmp,&nb);
    if (strcmp(tmp,"diceroll")==0) {
      if (nb>n) // For compatibility with 1.4 savegame.
	return (int) ((float) nb*n/(RAND_MAX+1.0)); 
      return nb;
    }
  }
  seedvalue = rand();
  int nb = (int) ((float) seedvalue*n/(RAND_MAX+1.0)); 
  if (store)
    man->recordCommand(QString("diceroll ")+QString::number(nb)); 
  return nb;
}

int Rand::simpleroll(int n)
{
  return (int) ((float) rand()*n/(RAND_MAX+1.0)); 
}
